#include "of.h"
#include "ui_of.h"

#include <io.h>
#include <QByteArray>
#include <QFile>

#include <QPainter>
#include <QImage>

QImage im(720, 492, QImage::Format_ARGB32);
QByteArray b;

of::of(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::of)
{
    ui->setupUi(this);

    //      
    QTextCodec::setCodecForCStrings(QTextCodec::codecForLocale()); //      
    QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));  // ("CP-1251"));

    b = MyOpenReadFile();

    QByteArray BMPFile;
    BMPFile.resize(54);
    BMPFile[0]  = 0x42; //  .  "B"
    BMPFile[1]  = 0x4D; //  .  "M"
    //   little-endian -        
    //   big-endian -        
    // (354240 + 54 = 354294)
    BMPFile[2]  = 0xF6; //  
    BMPFile[3]  = 0x67; //  
    BMPFile[4]  = 0x05; //  
    BMPFile[5]  = 0x00; //  

    BMPFile[6]  = 0x00; //      0x00
    BMPFile[7]  = 0x00; //      0x00
    BMPFile[8]  = 0x00; //      0x00
    BMPFile[9]  = 0x00; //      0x00

    //       
    BMPFile[10] = 0x36; // 
    BMPFile[11] = 0x00; // 
    BMPFile[12] = 0x00; // 
    BMPFile[13] = 0x00; // 

    //     40 (028)
    BMPFile[14] = 0x28;
    BMPFile[15] = 0x00;
    BMPFile[16] = 0x00;
    BMPFile[17] = 0x00;

    //  ,  (720 )
    BMPFile[18] = 0x00;
    BMPFile[19] = 0x2D;
    BMPFile[20] = 0x00;
    BMPFile[21] = 0x00;

    //  ,  (492 )
    BMPFile[22] = 0xEC;
    BMPFile[23] = 0x01;
    BMPFile[24] = 0x00;
    BMPFile[25] = 0x00;

    //  
    BMPFile[26] = 0x00;
    BMPFile[27] = 0x01;

    //     (24 )
    BMPFile[28] = 0x18;
    BMPFile[29] = 0x00;

    //   ( )
    BMPFile[30] = 0x00;
    BMPFile[31] = 0x00;
    BMPFile[32] = 0x00;
    BMPFile[33] = 0x00;

    //     (492 * 720 = 354240)
    BMPFile[34] = 0xC0;
    BMPFile[35] = 0x67;
    BMPFile[36] = 0x05;
    BMPFile[37] = 0x00;

    //  ,   
    BMPFile[38] = 0x00;
    BMPFile[39] = 0x00;
    BMPFile[40] = 0x00;
    BMPFile[41] = 0x00;

    //  ,   
    BMPFile[42] = 0x00;
    BMPFile[43] = 0x00;
    BMPFile[44] = 0x00;
    BMPFile[45] = 0x00;

    //    (0 -      )
    BMPFile[46] = 0x00;
    BMPFile[47] = 0x00;
    BMPFile[48] = 0x00;
    BMPFile[49] = 0x00;

    //   
    BMPFile[50] = 0x00;
    BMPFile[51] = 0x00;
    BMPFile[52] = 0x00;
    BMPFile[53] = 0x00;

    b.prepend(BMPFile);

    //  
    connect(ui->pushButton_2, SIGNAL(clicked()), this, SLOT(MyExit()));
}
of::~of()
{
    delete ui;
}
//  
void of::MyDraw()
{
   im = QImage::fromData(b, 0);

   QPainter Tochka;
   Tochka.begin(this);

   Tochka.translate(50, 50);

   Tochka.drawImage(0, 0, im, 0, 0, 720, 492);

   Tochka.end();
}
// 
void of::paintEvent(QPaintEvent *)
{
    QPainter painterRect(this);
    painterRect.setBrush(QBrush(Qt::black));
    painterRect.drawRect(0, 0, 1294, 681);

    MyDraw();
}
//   
void of::MyExit()
{
    QApplication::quit();
}

//    
QByteArray of::MyOpenReadFile()
{
    chdir("file");
    QFile file("1.dat");

    QByteArray mydata;

    if (file.open(file.ReadOnly))
    {
        mydata = file.readAll();
        file.close();

        mydata.remove(0, 8);
    }
    return mydata;
}
